I think there is an error in the MinimumDistance method of Rhino.Geometry.Line. When there are two colinear lines with different directions and the endpoints towards each other, it measures not the Minimum Distance, but the distance from end of line to the start of the other line (but end to end would be the minimum). But already the slightest angle between the lines result in correct results.
Please share a 3dm file with such a setup and code to reproduce the problem.
LineMinimumDistanceError.3dm (38.3 KB)
I checked it with this small python script
import Rhino.Geometry as rg
import rhinoscriptsyntax as rs
from scriptcontext import doc
ids = rs.GetObjects(“sel two lines”)
lines = [doc.Objects.Find(id).Geometry.Line for id in ids]
print lines[0].MinimumDistanceTo(lines[1])